var sinon  = require('sinon'),
    should = require('should'),
    needle = require('./../'),
    http = require('http'),
    fake;
  
describe('parsing', function(){
  
  describe('when response is an XML string', function(){
    
    before(function(){
      var response = {
        headers: { "Content-Type": 'application/xml' },
        body: "<post><body>hello there</body></post>"
      }
      fake = sinon.stub(http, 'request', function(opts, callback){
        callback(response);
      });
    });
    
    after(function(){
      fake.restore();
    })
    
    describe('and xml2js library is present', function(){
      
      describe('and parse_response is true', function(){
        
        it('should return JSON object', function(){
          needle.get('something.com', function(err, response, body){
            should.not.exist(err);
            body.should.equal({post: {body: 'hello there'}});
          })
        })
        
      })
      
      describe('and parse response is not true', function(){
  
        it('should return xml string', function(){
          
          
          
        })
        
      })
      
    })
    
    describe('and xml2js is not found', function(){

      before(function(){
        needle.parsers['application/xml'] = null;
      })

      it('should return xml string', function(){
        
      })
      
    })
    
    
  })
  
  
})
